# python build stubs for package extractor
# File is generated by gopy. Do not edit.
# gopy build --output=py_excel_form_extractor -vm=python3 ./pkg/extractor ./pkg/utils

from pybindgen import retval, param, Function, Module
import sys

class CheckedFunction(Function):
    def __init__(self, *a, **kw):
        super(CheckedFunction, self).__init__(*a, **kw)
        self._failure_expression = kw.get('failure_expression', '')
        self._failure_cleanup = kw.get('failure_cleanup', '')

    def set_failure_expression(self, expr):
        self._failure_expression = expr

    def set_failure_cleanup(self, expr):
        self._failure_cleanup = expr

    def generate_call(self):
        super(CheckedFunction, self).generate_call()
        check = "PyErr_Occurred()"
        if self._failure_expression:
            check = "{} && {}".format(self._failure_expression, check)
        failure_cleanup = self._failure_cleanup or None
        self.before_call.write_error_check(check, failure_cleanup)

def add_checked_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

def add_checked_string_function(mod, name, retval, params, failure_expression='', *a, **kw):
    fn = CheckedFunction(name, retval, params, *a, **kw)
    fn.set_failure_cleanup('if (retval != NULL) free(retval);')
    fn.after_call.add_cleanup_code('free(retval);')
    fn.set_failure_expression(failure_expression)
    mod._add_function_obj(fn)
    return fn

mod = Module('_extractor')
mod.add_include('"extractor_go.h"')
mod.add_function('GoPyInit', None, [])
mod.add_function('DecRef', None, [param('int64_t', 'handle')])
mod.add_function('IncRef', None, [param('int64_t', 'handle')])
mod.add_function('NumHandles', retval('int'), [])
mod.add_function('Slice_bool_CTor', retval('int64_t'), [])
mod.add_function('Slice_bool_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_bool_elem', retval('bool'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_bool_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_bool_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('bool', 'value')])
mod.add_function('Slice_bool_append', None, [param('int64_t', 'handle'), param('bool', 'value')])
mod.add_function('Slice_byte_CTor', retval('int64_t'), [])
mod.add_function('Slice_byte_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_byte_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_byte_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_byte_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_byte_from_bytes', retval('int64_t'), [param('PyObject*', 'o', transfer_ownership=False)])
mod.add_function('Slice_byte_to_bytes', retval('PyObject*', caller_owns_return=True), [param('int64_t', 'handle')])
mod.add_function('Slice_error_CTor', retval('int64_t'), [])
mod.add_function('Slice_error_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_error_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_error_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_error_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_error_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_float32_CTor', retval('int64_t'), [])
mod.add_function('Slice_float32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float32_elem', retval('float'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('float', 'value')])
mod.add_function('Slice_float32_append', None, [param('int64_t', 'handle'), param('float', 'value')])
mod.add_function('Slice_float64_CTor', retval('int64_t'), [])
mod.add_function('Slice_float64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_float64_elem', retval('double'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_float64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_float64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('double', 'value')])
mod.add_function('Slice_float64_append', None, [param('int64_t', 'handle'), param('double', 'value')])
mod.add_function('Slice_int_CTor', retval('int64_t'), [])
mod.add_function('Slice_int_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int16_CTor', retval('int64_t'), [])
mod.add_function('Slice_int16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int16_elem', retval('int16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int16_t', 'value')])
mod.add_function('Slice_int16_append', None, [param('int64_t', 'handle'), param('int16_t', 'value')])
mod.add_function('Slice_int32_CTor', retval('int64_t'), [])
mod.add_function('Slice_int32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int32_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_int32_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_int64_CTor', retval('int64_t'), [])
mod.add_function('Slice_int64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int64_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_int64_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
mod.add_function('Slice_int8_CTor', retval('int64_t'), [])
mod.add_function('Slice_int8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_int8_elem', retval('int8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_int8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_int8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int8_t', 'value')])
mod.add_function('Slice_int8_append', None, [param('int64_t', 'handle'), param('int8_t', 'value')])
mod.add_function('Slice_rune_CTor', retval('int64_t'), [])
mod.add_function('Slice_rune_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_rune_elem', retval('int32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_rune_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_rune_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int32_t', 'value')])
mod.add_function('Slice_rune_append', None, [param('int64_t', 'handle'), param('int32_t', 'value')])
mod.add_function('Slice_string_CTor', retval('int64_t'), [])
mod.add_function('Slice_string_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_string_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_string_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_string_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('Slice_string_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
mod.add_function('Slice_uint_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint16_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint16_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint16_elem', retval('uint16_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint16_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint16_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint16_t', 'value')])
mod.add_function('Slice_uint16_append', None, [param('int64_t', 'handle'), param('uint16_t', 'value')])
mod.add_function('Slice_uint32_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint32_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint32_elem', retval('uint32_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint32_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint32_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint32_t', 'value')])
mod.add_function('Slice_uint32_append', None, [param('int64_t', 'handle'), param('uint32_t', 'value')])
mod.add_function('Slice_uint64_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint64_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint64_elem', retval('uint64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint64_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint64_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint64_t', 'value')])
mod.add_function('Slice_uint64_append', None, [param('int64_t', 'handle'), param('uint64_t', 'value')])
mod.add_function('Slice_uint8_CTor', retval('int64_t'), [])
mod.add_function('Slice_uint8_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_uint8_elem', retval('uint8_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_uint8_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_uint8_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('uint8_t', 'value')])
mod.add_function('Slice_uint8_append', None, [param('int64_t', 'handle'), param('uint8_t', 'value')])
mod.add_function('Slice_extractor_CellRange_CTor', retval('int64_t'), [])
mod.add_function('Slice_extractor_CellRange_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('Slice_extractor_CellRange_elem', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('Slice_extractor_CellRange_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('Slice_extractor_CellRange_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('int64_t', 'value')])
mod.add_function('Slice_extractor_CellRange_append', None, [param('int64_t', 'handle'), param('int64_t', 'value')])
add_checked_string_function(mod, 'extractor_SheetNameGetter_GetSheetName', retval('char*'), [param('int64_t', '_handle')])
mod.add_function('extractor_CellRange_CTor', retval('int64_t'), [])
mod.add_function('extractor_CellRange_StartCell_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_CellRange_StartCell_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_CellRange_EndCell_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_CellRange_EndCell_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_DualColumnClfExtractor_CTor', retval('int64_t'), [])
mod.add_function('extractor_Response_CTor', retval('int64_t'), [])
mod.add_function('extractor_Response_Status_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_Response_Status_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_Response_Message_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_Response_Message_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_Response_Data_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_Response_Data_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_TriColumnClfExtractor_CTor', retval('int64_t'), [])
mod.add_function('extractor_BoolCheckBoxExtractor_CTor', retval('int64_t'), [])
mod.add_function('extractor_ClassificationCriteria_CTor', retval('int64_t'), [])
mod.add_function('extractor_ClassificationCriteria_Label_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ClassificationCriteria_Label_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ClassificationCriteria_SearchTerms_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_ClassificationCriteria_SearchTerms_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_ClassificationCriteria_Offset_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_ClassificationCriteria_Offset_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_ExcelExtractor_CTor', retval('int64_t'), [])
mod.add_function('extractor_ExcelExtractor_Extraction_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_ExcelExtractor_Extraction_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
add_checked_function(mod, 'extractor_ExcelExtractor_ReplaceCompanyNames', retval('int64_t'), [param('int64_t', '_handle'), param('int64_t', 'items')])
add_checked_string_function(mod, 'extractor_ExcelExtractor_GetCellValue', retval('char*'), [param('int64_t', '_handle'), param('int64_t', 'cellRange'), param('char*', 'sheetName')])
add_checked_function(mod, 'extractor_ExcelExtractor_ReadFormControls', None, [param('int64_t', '_handle'), param('bool', 'goRun')])
add_checked_function(mod, 'extractor_ExcelExtractor_Extract', retval('int64_t'), [param('int64_t', '_handle')])
add_checked_function(mod, 'extractor_ExcelExtractor_Close', retval('char*'), [param('int64_t', '_handle')])
mod.add_function('extractor_SearchCriteria_CTor', retval('int64_t'), [])
mod.add_function('extractor_SearchCriteria_SearchTerms_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_SearchTerms_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SearchCriteria_CellRanges_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_CellRanges_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SearchCriteria_DualColumnCheckBoxClf_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_DualColumnCheckBoxClf_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('extractor_SearchCriteria_DualColumnClfCriteria_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_DualColumnClfCriteria_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SearchCriteria_TriColumnCheckBoxClf_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_TriColumnCheckBoxClf_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('extractor_SearchCriteria_TriColumnClfCriteria_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_TriColumnClfCriteria_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SearchCriteria_BoolCheckBox_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_BoolCheckBox_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('extractor_SearchCriteria_BoolClfCriteria_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_BoolClfCriteria_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SearchCriteria_Offset_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SearchCriteria_Offset_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_BoolClassificationCriteria_CTor', retval('int64_t'), [])
mod.add_function('extractor_BoolClassificationCriteria_Offset_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_BoolClassificationCriteria_Offset_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_BoolClassificationCriteria_SearchTerms_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_BoolClassificationCriteria_SearchTerms_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_DualClassificationCriteria_CTor', retval('int64_t'), [])
mod.add_function('extractor_DualClassificationCriteria_TYPE_1_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_DualClassificationCriteria_TYPE_1_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_DualClassificationCriteria_TYPE_2_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_DualClassificationCriteria_TYPE_2_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SimpleValueExtractor_CTor', retval('int64_t'), [])
mod.add_function('extractor_BuyerDetails_CTor', retval('int64_t'), [])
mod.add_function('extractor_BuyerDetails_SheetName_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_SheetName_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_BuyerDetails_PartNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_PartNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_BuyerDetails_PartDescription_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_PartDescription_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_BuyerDetails_ClassificationOfItem_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_ClassificationOfItem_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_BuyerDetails_ControlListClassificationNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_ControlListClassificationNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_BuyerDetails_RFQ_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_RFQ_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_BuyerDetails_BuildToPrint_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_BuildToPrint_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('extractor_BuyerDetails_ManufacturedToSpecification_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_ManufacturedToSpecification_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('extractor_BuyerDetails_OriginalEquipmentManufacturer_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_OriginalEquipmentManufacturer_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
mod.add_function('extractor_BuyerDetails_Modified_Get', retval('bool'), [param('int64_t', 'handle')])
mod.add_function('extractor_BuyerDetails_Modified_Set', None, [param('int64_t', 'handle'), param('bool', 'val')])
add_checked_string_function(mod, 'extractor_BuyerDetails_GetSheetName', retval('char*'), [param('int64_t', '_handle')])
mod.add_function('extractor_DivideByZeroError_CTor', retval('int64_t'), [])
mod.add_function('extractor_ProductDetails_CTor', retval('int64_t'), [])
mod.add_function('extractor_ProductDetails_SheetName_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SheetName_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SupplierPartNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SupplierPartNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SupplierCompanyName_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SupplierCompanyName_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SupplierFullAddress_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SupplierFullAddress_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SupplierCountry_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SupplierCountry_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SupplierCompanyNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SupplierCompanyNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ManufacturerPartNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ManufacturerPartNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ManufacturerCompanyName_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ManufacturerCompanyName_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ManufacturerFullAddress_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ManufacturerFullAddress_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ManufacturerCountry_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ManufacturerCountry_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ManufacturerCompanyNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ManufacturerCompanyNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_CountryOfOrigin_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_CountryOfOrigin_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_CustomsTariffCode_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_CustomsTariffCode_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ExportControlRegulated_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ExportControlRegulated_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_PartClassification_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_PartClassification_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ControlListClassificationNumber_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ControlListClassificationNumber_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ThirdCountryControlledContent_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ThirdCountryControlledContent_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_EndUserStatementRequired_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_EndUserStatementRequired_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ExportLicenceShipmentRequired_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ExportLicenceShipmentRequired_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_ExportLicenceEndUserRequired_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_ExportLicenceEndUserRequired_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_AdditionalExportDocsRequired_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_AdditionalExportDocsRequired_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_TransferReexportConditions_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_TransferReexportConditions_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_RepresentativeName_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_RepresentativeName_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_RepresentativePosition_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_RepresentativePosition_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_RepresentativeCompany_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_RepresentativeCompany_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_RepresentativeSignature_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_RepresentativeSignature_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SupplierCompanySeal_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SupplierCompanySeal_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
mod.add_function('extractor_ProductDetails_SignatureDate_Get', retval('char*'), [param('int64_t', 'handle')])
mod.add_function('extractor_ProductDetails_SignatureDate_Set', None, [param('int64_t', 'handle'), param('char*', 'val')])
add_checked_string_function(mod, 'extractor_ProductDetails_GetSheetName', retval('char*'), [param('int64_t', '_handle')])
mod.add_function('extractor_SECCFExtraction_CTor', retval('int64_t'), [])
mod.add_function('extractor_SECCFExtraction_BuyerDetails_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SECCFExtraction_BuyerDetails_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SECCFExtraction_ProductDetails_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_SECCFExtraction_ProductDetails_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_SheetNotFoundError_CTor', retval('int64_t'), [])
add_checked_string_function(mod, 'extractor_SheetNotFoundError_Error', retval('char*'), [param('int64_t', '_handle')])
mod.add_function('extractor_TriClassificationCritera_CTor', retval('int64_t'), [])
mod.add_function('extractor_TriClassificationCritera_TYPE_1_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_TriClassificationCritera_TYPE_1_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_TriClassificationCritera_TYPE_2_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_TriClassificationCritera_TYPE_2_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_TriClassificationCritera_TYPE_3_Get', retval('int64_t'), [param('int64_t', 'handle')])
mod.add_function('extractor_TriClassificationCritera_TYPE_3_Set', None, [param('int64_t', 'handle'), param('int64_t', 'val')])
mod.add_function('extractor_CompanyNameList_CTor', retval('int64_t'), [])
mod.add_function('extractor_CompanyNameList_len', retval('int'), [param('int64_t', 'handle')])
mod.add_function('extractor_CompanyNameList_elem', retval('char*'), [param('int64_t', 'handle'), param('int', 'idx')])
mod.add_function('extractor_CompanyNameList_subslice', retval('int64_t'), [param('int64_t', 'handle'), param('int', 'st'), param('int', 'ed')])
mod.add_function('extractor_CompanyNameList_set', None, [param('int64_t', 'handle'), param('int', 'idx'), param('char*', 'value')])
mod.add_function('extractor_CompanyNameList_append', None, [param('int64_t', 'handle'), param('char*', 'value')])
add_checked_function(mod, 'extractor_MakeSECCFExtractor', retval('int64_t'), [param('char*', 'filePath'), param('int64_t', 'companyNames')])
add_checked_string_function(mod, 'utils_RemoveExtraSpaces', retval('char*'), [param('char*', 'value')])

mod.generate(open('extractor.c', 'w'))

